<template>
    <div class="list-view">
        <div class="filters-container">
            <!-- <el-input placeholder="输入关键字" v-model="search" clearable class="filter-item"></el-input>
            <el-button @click="getData" type="primary" icon="el-icon-search" class="filter-item">搜索 </el-button> -->
            <el-button @click="addRow" type="primary" icon="el-icon-plus" class="filter-item">添加 </el-button>
            <!-- <el-button
                @click="download"
                type="primary"
                icon="el-icon-download"
                :loading="downloading"
                class="filter-item"
                >导出EXCEL
            </el-button> -->
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <!-- <el-table-column prop="id" label="ID" width="100"> </el-table-column> -->
            <el-table-column prop="name" label="活动名称" min-width="190"> </el-table-column>
            <el-table-column prop="year" label="年度"> </el-table-column>
            <el-table-column prop="status" label="活动状态" width="80">
                <template slot-scope="{ row }">
                    <el-link style="font-size: 13px" :underline="false" type="info" v-if="currentTime < row.startDate"
                        >未开始</el-link
                    >
                    <el-link
                        style="font-size: 13px"
                        :underline="false"
                        type="info"
                        v-else-if="currentTime > row.endDate"
                        >已结束</el-link
                    >
                    <el-link
                        style="font-size: 13px"
                        :underline="false"
                        type="success"
                        v-else-if="currentTime <= row.endDate"
                        >报名中</el-link
                    >
                </template>
            </el-table-column>
            <el-table-column label="发布状态">
                <template slot-scope="{ row }">
                    <span v-if="row.publish">已发布</span>
                    <span v-else>未发布</span>
                </template>
            </el-table-column>
            <el-table-column label="推送节目数量" prop="programmeNum">
                <template slot-scope="{ row }">
                    <el-link @click="programmeRow(row)">{{ row.programmeNum }}</el-link>
                </template>
            </el-table-column>
            <el-table-column label="操作" align="left" fixed="right" min-width="160">
                <template slot-scope="{ row }">
                    <el-button @click="showRow(row)" size="mini" plain>
                        查看
                    </el-button>
                    <el-button @click="editRow(row)" type="success" size="mini" plain>
                        编辑
                    </el-button>
                    <el-button
                        @click="publish(row, true)"
                        type="primary"
                        size="mini"
                        plain
                        v-if="!row.publish && row.programmeNum == 0"
                    >
                        发布
                    </el-button>
                    <el-button
                        @click="publish(row, false)"
                        type="warning"
                        size="mini"
                        plain
                        v-if="row.publish && row.programmeNum == 0"
                    >
                        撤销
                    </el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';
import { format } from 'date-fns';

export default {
    name: 'PerformanceList',
    mixins: [pageableTable],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/performance/backAll',
            downloading: false,
            currentTime: ''
        };
    },
    created() {
        this.currentTime = format(new Date(), 'yyyy-MM-dd');
        // console.log(this.currentTime);
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        },
        ...mapState(['userInfo'])
    },
    methods: {
        beforeGetData() {
            return {
                search: this.search,
                sort: 'createdAt,desc'
            };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/performanceEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        showRow(row) {
            this.$router.push({
                path: '/performanceShow',
                query: {
                    id: row.id
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/performanceEdit',
                query: {
                    id: row.id
                }
            });
        },
        programmeRow(row) {
            this.$router.push({
                path: '/programmeList',
                query: {
                    pid: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/performance/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/performance/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        },
        handleCommand(command) {
            if (command) {
                this.$router.push(command);
            }
        },
        publish(row, publish) {
            this.$confirm('确认发布此展演活动吗？', '发布提示', { type: 'primary' })
                .then(() => {
                    return this.$http.post('/performance/publish', { id: row.id, publish: publish });
                })
                .then(() => {
                    this.$message.success('发布成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
